package de.ozgcloud.apilib.vorgang;

import java.util.Collection;
import java.util.Optional;

import lombok.Builder;
import lombok.Getter;
import lombok.Singular;

@Builder
@Getter
public class OzgCloudVorgangQuery {
	@Builder.Default
	private final Optional<String> organisationsEinheitId = Optional.empty();
	@Builder.Default
	private final Optional<FormIdentification> form = Optional.empty();
	@Builder.Default
	private final Optional<String> status = Optional.empty();
	@Builder.Default
	private final Optional<String> aktenzeichen = Optional.empty();

	@Builder.Default
	public final Optional<Query> query = Optional.empty();

	@Builder
	@Getter
	public static class Query {
		private final LogicalOperator logicalOperator;
		@Singular
		private final Collection<Expression> expressions;
		private final Query nestedQuery;
	}

	@Builder
	@Getter
	public static class FormIdentification {
		private String formId;
		private String formEngineName;
	}

	public enum LogicalOperator {
		AND, OR
	}

	@Builder
	@Getter
	public static class Expression {
		private final String path;
		private final ComparsionOperator operator;
		private final Integer operandIntValue;
		private final Boolean operandBoolValue;
		private final String operandStringValue;

		public enum ComparsionOperator {
			GREATER_THEN, // >
			GREATER_THEN_OR_EQUAL_TO, // >=
			LESS_THEN, // <
			LESS_THEN_OR_EQUAL_TO, // <=
			EQUAL, // =
			UNEQUAL, // <>
			IS_NULL,
			IS_EMPTY,
			EXISTS,
			NOT_EXIST;
		}

	}
}