package de.ozgcloud.apilib.file;

import java.util.UUID;

public class OzgCloudFileTestFactory {

	public static final String ID_STR = UUID.randomUUID().toString();
	public static final OzgCloudFileId ID = OzgCloudFileId.from(ID_STR);
	public static final String NAME = "testfile.pdf";
	public static final String CONTENT_TYPE = "application/pdf";
	public static final long SIZE = 1024;

	public static OzgCloudFile create() {
		return createBuilder().build();
	}

	public static OzgCloudFile.OzgCloudFileBuilder createBuilder() {
		return OzgCloudFile.builder()
				.id(ID)
				.name(NAME)
				.contentType(CONTENT_TYPE)
				.size(SIZE);
	}
}
